﻿(function () {
    "use strict";

    var aktuellerArtikel;

    WinJS.Namespace.define("rssData", {
        WollmilchRSS: WinJS.Class.define(
            function WollmilchRSS(url) {

                var _dataArray = [];
                var _bindingList = new WinJS.Binding.List();

                this.url = url;
                this.bindingList = _bindingList;
                this.dataSource = _bindingList.dataSource;
            },
            {
                feedAbholen: function () {

                    var that = this;

                    WinJS.xhr({
                        type: "GET",
                        url: that.url,
                        responseType: "document"
                    }).then(
                    function erfolg(daten) {
                        // Erfolgshandler
                        if (daten.status < 200 || daten.status >= 300) {
                            var dialog = new Windows.UI.Popups.MessageDialog("Leider konnte der Feed nicht abgerufen werden.");
                            dialog.showAsync();
                        } else {
                            var artikel = daten.responseXML.querySelectorAll("item");

                            for (var n = 0; n < artikel.length; n++) {
                                var einzelArtikel = {};

                                einzelArtikel.titel = artikel[n].querySelector("title").textContent;
                                einzelArtikel.link = artikel[n].querySelector("link").textContent;
                                einzelArtikel.inhalt = artikel[n].querySelector("description").textContent;
                                einzelArtikel.vorschautext = einzelArtikel.inhalt.substring(0, 100) + "...";

                                var thumbs = artikel[n].querySelectorAll("enclosure");

                                if (thumbs.length > 0) {
                                    einzelArtikel.thumbnail =
                                       "url('" + thumbs[0].attributes.getNamedItem("url").textContent + "')";
                                    that.bindingList.push(einzelArtikel);
                                }
                            }
                        }
                        WinJS.Application.queueEvent({ type: "feedDatenLadenFertig" });
                    },
                    function fehler(fehlerobjekt) {
                        // Fehlerhandler
                        console.log("Fehler " + fehlerobjekt);
                        var dialog = new Windows.UI.Popups.MessageDialog("Leider konnte der Feed nicht abgerufen werden.");
                        dialog.showAsync();
                        WinJS.Application.queueEvent({ type: "feedDatenLadenFertig" });
                    });
                },
            }
        ),
        aktuellerArtikel: aktuellerArtikel
    });
})();
