﻿(function () {
    "use strict";

    var aktuellerArtikel;

    WinJS.Namespace.define("rssData", {
        WollmilchRSS: WinJS.Class.define(
            function WollmilchRSS(url) {

                var _dataArray = [];
                var _bindingList = new WinJS.Binding.List();

                this.url = url;
                this.bindingList = _bindingList;
                //this.dataSource = _bindingList.dataSource;

                //Neu
                var _gruppierteBindingList = _bindingList.createGrouped(
                    function gruppenKey(i) { return i.monat + "_" + i.jahr; },
                    function gruppenDaten(i) { return { gruppe: i.gruppe, monat: i.monat, jahr: i.jahr }; },
                    function gruppenVergleich(a, b) {
                        var a = a.split("_");
                        var b = b.split("_");
                        var aJahr = a[1];
                        var aMonat = a[0];
                        var bJahr = b[1];
                        var bMonat = b[0];

                        if (aJahr > bJahr) {
                            return -1;
                        }
                        else if (aJahr == bJahr) {
                            if (aMonat > bMonat) { return 1 }
                            else if (aMonat == bMonat) { return 0 }
                            else { return -1 }
                        }
                        else if (aJahr < bJahr) {
                            return 1;
                        }
                    }
                    );

                this.dataSource = _gruppierteBindingList.dataSource;
                this.gruppierteBindingList = _gruppierteBindingList;
                this.gruppenBindingList = _gruppierteBindingList.groups;
                this.gruppenDataSource = _gruppierteBindingList.groups.dataSource;
                //Ende Neu
            },
            {
                feedAbholen: function () {

                    var that = this;

                    WinJS.xhr({
                        type: "GET",
                        url: that.url,
                        responseType: "document"
                    }).then(
                    function erfolg(daten) {
                        // Erfolgshandler
                        if (daten.status < 200 || daten.status >= 300) {
                            var dialog = new Windows.UI.Popups.MessageDialog("Leider konnte der Feed nicht abgerufen werden.");
                            dialog.showAsync();
                        } else {
                            that.bindingList.length = 0;
                            that.gruppierteBindingList.length = 0;

                            var artikel = daten.responseXML.querySelectorAll("item");

                            for (var n = 0; n < artikel.length; n++) {
                                var einzelArtikel = {};

                                einzelArtikel.titel = artikel[n].querySelector("title").textContent;
                                einzelArtikel.link = artikel[n].querySelector("link").textContent;
                                einzelArtikel.inhalt = artikel[n].querySelector("description").textContent;
                                einzelArtikel.vorschautext = einzelArtikel.inhalt.substring(0, 100) + "...";

                                // Neu
                                var monatsNamen = ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September",
                                    "Oktober", "November", "Dezember"];
                                var artikelDatum = new Date(artikel[n].querySelector("pubDate").textContent);
                                einzelArtikel.gruppe = monatsNamen[artikelDatum.getMonth()] + " " + artikelDatum.getFullYear();
                                einzelArtikel.monat = artikelDatum.getMonth();
                                einzelArtikel.jahr = artikelDatum.getFullYear();
                                // Ende Neu

                                var thumbs = artikel[n].querySelectorAll("enclosure");

                                if (thumbs.length > 0) {
                                    einzelArtikel.thumbnail =
                                       "url('" + thumbs[0].attributes.getNamedItem("url").textContent + "')";
                                    that.bindingList.push(einzelArtikel);
                                }
                            }
                        }
                        WinJS.Application.queueEvent({ type: "feedDatenLadenFertig" });
                    },
                    function fehler(fehlerobjekt) {
                        // Fehlerhandler
                        console.log("Fehler " + fehlerobjekt);
                        var dialog = new Windows.UI.Popups.MessageDialog("Leider konnte der Feed nicht abgerufen werden.");
                        dialog.showAsync();
                        WinJS.Application.queueEvent({ type: "feedDatenLadenFertig" });
                    });
                },
            }
        ),
        aktuellerArtikel: aktuellerArtikel
    });
})();
