﻿(function () {
    "use strict";

    WinJS.UI.Pages.define("/pages/home/home.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            // TODO: Initialize the page here.
            var wollmilchRSS = new rssData.WollmilchRSS("http://felixrieseberg.com/deutsch/feed/rss");
            wollmilchRSS.feedAbholen();

            var meinListView = document.getElementById("meinListView").winControl;

            //Neu
            meinListView.groupDataSource = wollmilchRSS.gruppenDataSource;
            meinListView.itemDataSource = wollmilchRSS.dataSource;

            var meinSemanticListView = document.getElementById("meinSemanticListView").winControl;
            meinSemanticListView.itemDataSource = wollmilchRSS.gruppenDataSource;

            meinListView.onselectionchanged = selectionChangedHandler;

            var meineAppBar = document.getElementById("appbar").winControl;
            meineAppBar.showOnlyCommands(['btnFeedback', 'btnRefresh']);

            function selectionChangedHandler(e) {
                if (meinListView.selection.count() > 0) {
                    meineAppBar.showCommands('btnPinnen')
                    meineAppBar.show();
                    meineAppBar.sticky = true;
                }
                else {
                    meineAppBar.hideCommands('btnPinnen')
                    meineAppBar.hide();
                    meineAppBar.sticky = false;
                }
            };

            var aktualisierenButton = document.getElementById("btnRefresh");
            aktualisierenButton.onclick = aktualisierenButtonHandler;
            WinJS.Application.addEventListener("feedDatenLadenFertig", function (e) { aktualisierenButton.deactivated = false; });

            function aktualisierenButtonHandler(e) {
                this.deactivated = true;
                wollmilchRSS.feedAbholen();
            };

            meinListView.oniteminvoked = itemInvokedHandler;

            function itemInvokedHandler(e) {
                rssData.aktuellerArtikel = e.detail.itemPromise._value.data;
                WinJS.Navigation.navigate("/pages/detailview/detailview.html");
            };

            // Neu: Resize handling
            function meinViewState() {
                var aktuellerViewState = Windows.UI.ViewManagement.ApplicationView.value;
                var meineViewStates = Windows.UI.ViewManagement.ApplicationViewState;

                switch (aktuellerViewState) {
                    case meineViewStates.snapped:
                        // Auf "Snap View" reagieren
                        meinListView.layout = new WinJS.UI.ListLayout;
                        meinListView.itemTemplate = document.getElementById("meineSVElementVorlage");
                        meinSemanticListView.layout = new WinJS.UI.ListLayout;
                        meinSemanticListView.itemTemplate = document.getElementById("meineSVGruppenVorlage");
                        break;
                    default:
                        // Auf alle anderen View States reagieren
                        meinListView.layout = new WinJS.UI.GridLayout;
                        meinListView.itemTemplate = document.getElementById("meineElementVorlage");
                        meinSemanticListView.layout = new WinJS.UI.GridLayout;
                        meinSemanticListView.itemTemplate = document.getElementById("meineGruppenVorlage");
                        break;
                }
            }

            window.addEventListener("load", meinViewState);
            window.addEventListener("resize", meinViewState);
            meinViewState();


        },
        unload: function () {
            WinJS.Application.removeEventListener("feedDatenLadenFertig",
                function (e) { aktualisierenButton.deactivated = false; });
        }
    });
})();
