﻿(function () {
    "use strict";

    function backgroundTaskAnmelden() {

        var background = Windows.ApplicationModel.Background;
        var name = "MeinBackgroundTask";

        if (background.BackgroundTaskRegistration.allTasks.size > 0) {

            var iterator = background.BackgroundTaskRegistration.allTasks.first();
            var taskVorhanden = iterator.hasCurrent;

            while (taskVorhanden) {
                var aktuellerTask = iterator.current.value;
                if (aktuellerTask.name === name) {
                    aktuellerTask.unregister(true);
                };
                taskVorhanden = iterator.moveNext();
            }
        }

        var builder = new Windows.ApplicationModel.Background.BackgroundTaskBuilder();

        var zeitZonenTrigger = background.SystemTriggerType.timeZoneChange;
        var systemEventTrigger = new background.SystemTrigger(zeitZonenTrigger, false);
        var nutzerBedingung = background.SystemConditionType.userPresent;
        var bedingung = background.SystemCondition(nutzerBedingung);

        builder.name = name;
        builder.taskEntryPoint = "js\\backgroundTask.js";
        builder.setTrigger(systemEventTrigger);
        builder.addCondition(bedingung)

        var task = builder.register();
    }


    WinJS.Namespace.define("BackgroundTasks", {
        backgroundTaskAnmelden: backgroundTaskAnmelden
    });

})();
