﻿(function () {
    "use strict";

    WinJS.UI.Pages.define("/pages/home/home.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            // TODO: Initialize the page here.
            var wollmilchRSS = new rssData.WollmilchRSS("http://felixrieseberg.com/deutsch/feed/rss");
            wollmilchRSS.feedAbholen();

            var meinListView = document.getElementById("meinListView").winControl;

            //Neu
            meinListView.groupDataSource = wollmilchRSS.gruppenDataSource;
            meinListView.itemDataSource = wollmilchRSS.dataSource;

            var meinSemanticListView = document.getElementById("meinSemanticListView").winControl;
            meinSemanticListView.itemDataSource = wollmilchRSS.gruppenDataSource;

            var meineAppBar = document.getElementById("appbar").winControl;
            meineAppBar.showOnlyCommands(['btnFeedback', 'btnRefresh']);

            meinListView.onselectionchanged = selectionChangedHandler;
            function selectionChangedHandler(e) {
                if (meinListView.selection.count() > 0) {
                    meineAppBar.showCommands('btnPinnen')
                    meineAppBar.show();
                    meineAppBar.sticky = true;

                    meinListView.selection.getItems().done(
                        function erfolg(auswahl) {
                            rssData.aktuellerArtikel = auswahl[0].data;
                        });
                }
                else {
                    meineAppBar.hideCommands('btnPinnen')
                    meineAppBar.hide();
                    meineAppBar.sticky = false;

                    rssData.aktuellerArtikel = null;
                }
            };

            var aktualisierenButton = document.getElementById("btnRefresh");
            aktualisierenButton.onclick = aktualisierenButtonHandler;
            WinJS.Application.addEventListener("feedDatenLadenFertig", function (e) { aktualisierenButton.deactivated = false; });

            function aktualisierenButtonHandler(e) {
                this.deactivated = true;
                wollmilchRSS.feedAbholen();
            };

            meinListView.oniteminvoked = itemInvokedHandler;

            function itemInvokedHandler(e) {
                rssData.aktuellerArtikel = e.detail.itemPromise._value.data;
                WinJS.Navigation.navigate("/pages/detailview/detailview.html");
            };

            // Neu: Resize handling
            function meinViewState() {
                var aktuellerViewState = Windows.UI.ViewManagement.ApplicationView.value;
                var meineViewStates = Windows.UI.ViewManagement.ApplicationViewState;

                switch (aktuellerViewState) {
                    case meineViewStates.snapped:
                        // Auf "Snap View" reagieren
                        meinListView.layout = new WinJS.UI.ListLayout;
                        meinListView.itemTemplate = document.getElementById("meineSVElementVorlage");
                        meinSemanticListView.layout = new WinJS.UI.ListLayout;
                        meinSemanticListView.itemTemplate = document.getElementById("meineSVGruppenVorlage");
                        break;
                    default:
                        // Auf alle anderen View States reagieren
                        meinListView.layout = new WinJS.UI.GridLayout;
                        meinListView.itemTemplate = document.getElementById("meineElementVorlage");
                        meinSemanticListView.layout = new WinJS.UI.GridLayout;
                        meinSemanticListView.itemTemplate = document.getElementById("meineGruppenVorlage");
                        break;
                }
            }

            window.addEventListener("load", meinViewState);
            window.addEventListener("resize", meinViewState);
            meinViewState();

            document.getElementById("btnPinnen").onclick = artikelPinnen;
            function artikelPinnen(e) {
                var gewaehlteArtikel = meinListView.selection.getIndices();
                var meinArtikel = wollmilchRSS.bindingList.getAt(gewaehlteArtikel[0]);
                var startscreen = Windows.UI.StartScreen;

                var id = "rssKachel" + Math.random();
                var kurzname = "RSS Artikel";
                var anzeigename = "RSS Artikel";
                var aktivierungsArguments = meinArtikel.titel;
                var optionen = startscreen.TileOptions.none;
                var logo = new Windows.Foundation.Uri("ms-appx:///images/sekundaerKachel_150x150.png")

                var kachel = new startscreen.SecondaryTile(id, kurzname, anzeigename, aktivierungsArguments,
                    optionen, logo);

                kachel.requestCreateAsync().then(
                    function (ergebnis) {
                        if (ergebnis == true) {
                            var notifications = Windows.UI.Notifications;
                            var meineVorlage = notifications.TileTemplateType.tileSquareText02;
                            var meinVorlagenXML = notifications.TileUpdateManager.getTemplateContent(meineVorlage);

                            var kachelUpdateText = meinVorlagenXML.getElementsByTagName("text");
                            var titel = meinVorlagenXML.createTextNode("RSS");
                            var artikelTitel = meinVorlagenXML.createTextNode(meinArtikel.titel);
                            kachelUpdateText[0].appendChild(titel);
                            kachelUpdateText[1].appendChild(artikelTitel);

                            var kachelBenachrichtigung = new notifications.TileNotification(meinVorlagenXML);
                            var tileUpdater = notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(id);
                            tileUpdater.update(kachelBenachrichtigung);

                        }
                    });
            };

        },
        unload: function () {
            WinJS.Application.removeEventListener("feedDatenLadenFertig",
                function (e) { aktualisierenButton.deactivated = false; });
        }
    });
})();
