﻿// For an introduction to the Navigation template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232506
(function () {
    "use strict";

    WinJS.Binding.optimizeBindingReferences = true;

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    var nav = WinJS.Navigation;

    app.addEventListener("activated", function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {

            var dataTransferManager = Windows.ApplicationModel.DataTransfer.DataTransferManager.getForCurrentView();
            dataTransferManager.addEventListener("datarequested", teilenVertrag.shareHandler);

            var playToManager = Windows.Media.PlayTo.PlayToManager.getForCurrentView();
            playToManager.addEventListener("sourcerequested", wiedergabeVertrag.playToHandler);

            if (args.detail.tileId.indexOf("rssKachel") !== -1) {
                var options = {};
                options.titel = args.detail.detail[0].arguments;
                options.type = "kachelEinstieg";
                nav.navigate("/pages/detailview/detailview.html", options);
            }

            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }

            if (app.sessionState.history) {
                nav.history = app.sessionState.history;
            }
            args.setPromise(WinJS.UI.processAll().then(function () {
                if (nav.location) {
                    nav.history.current.initialPlaceholder = true;
                    return nav.navigate(nav.location, nav.state);
                } else {
                    return nav.navigate(Application.navigator.home);
                }
            }));
        }
    });



    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. If you need to 
        // complete an asynchronous operation before your application is 
        // suspended, call args.setPromise().
        app.sessionState.history = nav.history;
    };

    app.onready = function (args) {
        var rssButton = document.getElementById("rssButton");
        var radioButton = document.getElementById("radioButton");
        var uhrenButton = document.getElementById("uhrenButton");
        var cockpitButton = document.getElementById("cockpitButton");
        rssButton.onclick = function () { WinJS.Navigation.navigate("/pages/home/home.html"); };
        radioButton.onclick = function () { WinJS.Navigation.navigate("/pages/radio/radio.html"); };
        uhrenButton.onclick = function () { WinJS.Navigation.navigate("/pages/uhr/uhr.html"); }
        cockpitButton.onclick = function () { WinJS.Navigation.navigate("/pages/cockpit/cockpit.html"); }
    };

    app.start();
})();
