﻿(function () {
    "use strict";

    var backgroundTaskInstance = Windows.UI.WebUI.WebUIBackgroundTaskInstance.current;
    backgroundTaskInstance.addEventListener("canceled", onCanceled);

    var cancel = false;

    function hintergrundArbeit() {
        Windows.UI.StartScreen.SecondaryTile.findAllAsync().done(
            function (sekundaerKacheln) {
                if (sekundaerKacheln.size > 0) {
                    for (var n = 0; n < sekundaerKacheln.size; n++) {
                        if (sekundaerKacheln[n].shortName == "Kacheluhr") {
                            var tileUpdater = Windows.UI.Notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(
                                sekundaerKacheln[n].tileId);
                            tileUpdater.clear();

                            var notifications = Windows.UI.Notifications;
                            var aktuellesDatum = new Date();
                            var aktuelleZeit = new Date(aktuellesDatum.setSeconds(0));

                            for (var addMinutes = 1; addMinutes < 300; addMinutes++) {

                                var vonZeit = new Date(aktuelleZeit.getTime() + 60000 * addMinutes);
                                var bisZeit = new Date(vonZeit.getTime() + 60000)
                                var idNummer = Math.floor(Math.random() * 100000000);

                                // Vorlage zusammensetzen
                                var vorlage = notifications.TileTemplateType.tileSquareText02;
                                var kachelXml = notifications.TileUpdateManager.getTemplateContent(vorlage);

                                var zeitFuerKachel = {}
                                zeitFuerKachel.minutes = vonZeit.getMinutes();
                                zeitFuerKachel.hours = vonZeit.getHours();
                                if (zeitFuerKachel.minutes < 10) { zeitFuerKachel.minutes = "0" + zeitFuerKachel.minutes };
                                if (zeitFuerKachel.hours < 10) { zeitFuerKachel.hours = "0" + zeitFuerKachel.hours };

                                var tileTextAttributes = kachelXml.getElementsByTagName("text");
                                tileTextAttributes[0].appendChild(kachelXml.createTextNode(
                                    zeitFuerKachel.hours + ":" + zeitFuerKachel.minutes));

                                // In ein Benachrichtigungs-Objekt verpacken...
                                var futureTile = new notifications.ScheduledTileNotification(kachelXml, vonZeit);
                                futureTile.id = "Tile" + idNummer;
                                futureTile.expirationTime = bisZeit;

                                // Und abschicken!
                                tileUpdater.addToSchedule(futureTile);
                            }
                        }

                    };
                }
            });

        close();
    }

    function onCanceled(cancelSender, cancelReason) {
        cancel = true;
    }

    if (!cancel) {
        hintergrundArbeit();
    } else {
        close();
    }

})();
