﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    var kompass = null;
    var inklinometer = null;
    var accelerometer = null;
    var gyrometer = null;
    var lichtsensor = null;
    var gps = null;

    WinJS.UI.Pages.define("/pages/cockpit/cockpit.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            // TODO: Initialize the page here.

            // Kompass
            kompass = Windows.Devices.Sensors.Compass.getDefault();
            if (kompass) {
                kompass.reportInterval = kompass.minimumReportInterval;
                kompass.onreadingchanged = kompassReadingChanged;
            } else {
                kapitaenGruss.innerText = "Kapitän, wir haben keinen Kompass!";
            };

            function kompassReadingChanged(daten) {
                var ergebnis = daten.reading;
                var magNord = ergebnis.headingMagneticNorth.toFixed(2);
                kurs.innerText = magNord;

                if (magNord >= 0 && magNord <= 45 || magNord > 315) {
                    kursGross.innerText = "N";
                } else if (magNord > 45 && magNord <= 135) {
                    kursGross.innerText = "O";
                } else if (magNord > 135 && magNord <= 225) {
                    kursGross.innerText = "S";
                } else if (magNord > 225 && magNord <= 315) {
                    kursGross.innerText = "W";
                }

            };

            // Inklinometer
            inklinometer = Windows.Devices.Sensors.Inclinometer.getDefault();
            if (inklinometer) {
                inklinometer.reportInterval = inklinometer.minimumReportInterval;
                inklinometer.onreadingchanged = inklinometerReadingChanged;
            } else {
                inklinometerGruss.innerText = "Wir haben kein Inklinometer!"
            };

            function inklinometerReadingChanged(daten) {
                var ergebnis = daten.reading;
                var pitch = ergebnis.pitchDegrees;
                var roll = ergebnis.rollDegrees;
                var yaw = ergebnis.yawDegrees;

                pitchText.innerText = pitch.toFixed(2);
                rollText.innerText = roll.toFixed(2);
                yawText.innerText = yaw.toFixed(2);
            };

            // Accelerometer
            accelerometer = Windows.Devices.Sensors.Accelerometer.getDefault();
            if (accelerometer) {
                accelerometer.reportInterval = accelerometer.minimumReportInterval;
                accelerometer.onreadingchanged = accelerometerReadingChanged;
            } else {
                accelerometerGruss.innerText = "Wir haben kein Accelerometer!"
            }

            function accelerometerReadingChanged(daten) {
                var ergebnis = daten.reading;
                var X = ergebnis.accelerationX;
                var Y = ergebnis.accelerationY;
                var Z = ergebnis.accelerationZ;

                xAcc.innerText = X.toFixed(2);
                yAcc.innerText = Y.toFixed(2);
                zAcc.innerText = Z.toFixed(2);
            };

            // Gyrometer
            gyrometer = Windows.Devices.Sensors.Gyrometer.getDefault();
            if (gyrometer) {
                gyrometer.reportInterval = gyrometer.minimumReportInterval;
                gyrometer.onreadingchanged = gyrometerReadingChanged;
            } else {
                gyrometerGruss.innerText = "Wir haben kein Gyrometer!"
            }

            function gyrometerReadingChanged(daten) {
                var ergebnis = daten.reading;
                var X = ergebnis.angularVelocityX;
                var Y = ergebnis.angularVelocityY;
                var Z = ergebnis.angularVelocityZ;

                xGyr.innerText = X.toFixed(2);
                yGyr.innerText = Y.toFixed(2);
                zGyr.innerText = Z.toFixed(2);
            };

            // Lichtsensor
            lichtsensor = Windows.Devices.Sensors.LightSensor.getDefault();
            if (lichtsensor) {
                lichtsensor.reportInterval = lichtsensor.minimumReportInterval;
                lichtsensor.onreadingchanged = lichtsensorReadingChanged;
            } else {
                lichtsensorGruss.innerText = "Wir haben keinen Lichtsensor!"
            }

            function lichtsensorReadingChanged(daten) {
                var ergebnis = daten.reading;
                var luxWert = ergebnis.illuminanceInLux;
                lux.innerText = luxWert.toFixed(2);
            };

            // GPS
            gps = new Windows.Devices.Geolocation.Geolocator();
            if (gps != null) {
                gps.onpositionchanged = gpsPositionsHandler;
                gps.onstatuschanged = gpsStatusHandler;
            }

            function gpsPositionsHandler(daten) {
                breitengradText.innerText = daten.position.coordinate.latitude;
                laengengradText.innerText = daten.position.coordinate.longitude;
                genauigkeitText.innerText = daten.position.coordinate.accuracy;
                gpsStatusText.innerText = gpsStatus(gps.locationStatus);
            }

            function gpsStatusHandler(daten) {
                gpsStatusText.innerText = "Status gemeldet: " + gpsStatus(daten.status);
            }

            function gpsStatus(status) {
                switch (status) {
                    case Windows.Devices.Geolocation.PositionStatus.ready:
                        return "Position verfügbar, Kapitän!";
                        break;
                    case Windows.Devices.Geolocation.PositionStatus.initializing:
                        return "Kapitän, wir suchen noch Satelliten!";
                        break;
                    case Windows.Devices.Geolocation.PositionStatus.noData:
                        return "Kapitän, es sind keine Daten verfügbar!";
                        break;
                    case Windows.Devices.Geolocation.PositionStatus.disabled:
                        return "Kapitän, wir haben keinen Zugriff!";
                        break;
                    case Windows.Devices.Geolocation.PositionStatus.notAvailable:
                        return "Kapitän, wir haben kein GPS!";
                        break;
                    case Windows.Devices.Geolocation.PositionStatus.notInitialized:
                        // Sollte nicht auftreten - tritt nur auf, wenn keine Daten angefordert wurden
                        break;
                    default:
                        break;
                }
            }

        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
            if (kompass) {
                kompass.onreadingchanged = null;
            }
            if (inklinometer) {
                inklinometer.onreadingchanged = null;
            }
            if (accelerometer) {
                accelerometer.onreadingchanged = null;
            }
            if (gyrometer) {
                gyrometer.onreadingchanged = null;
            }
            if (lichtsensor) {
                lichtsensor.onreadingchanged = null;
            }
            if (gps) {
                gps.onpositionchanged = null;
                gps.onstatuschanged = null;
            }
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });
})();
