﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    WinJS.UI.Pages.define("/pages/uhr/uhr.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            var background = Windows.ApplicationModel.Background;
            var accessStatus = background.BackgroundAccessStatus;
            var accessAbgelehnt = accessStatus.denied;
            var accessUnsicher = accessStatus.unspecified;
            var accessMitStandby = accessStatus.allowedWithAlwaysOnRealTimeConnectivity;
            var accessOhneStandby = accessStatus.allowedMayUseActiveRealTimeConnectivity;

            sperrbildschirmRequest.onclick = erbitteSperrbildschirm;
            kachelLegen.onclick = kachelPinnen;

            // Uhr starten
            window.intervalUhr = setInterval(
                function () {
                    uhr.innerText = new Date().toLocaleTimeString();
                }, 250);

            // Sind wir Sperrbildschirm-App?
            function checkeSperrbildschirm(ergebnis) {
                if (!ergebnis) {
                    var ergebnis = background.BackgroundExecutionManager.getAccessStatus()
                };
                if (ergebnis === accessUnsicher) {
                    kachelText.style.display = "none";
                    sperrbildschirmText.style.display = "block";
                    sperrbildschirmFehler.style.display = "none";
                } else if (ergebnis === accessMitStandby || ergebnis === accessOhneStandby) {
                    kachelText.style.display = "block";
                    sperrbildschirmText.style.display = "none";
                    sperrbildschirmFehler.style.display = "none";
                } else if (ergebnis === accessAbgelehnt) {
                    kachelText.style.display = "none";
                    sperrbildschirmText.style.display = "none";
                    sperrbildschirmFehler.style.display = "block";
                }
            };

            checkeSperrbildschirm();

            // Sperrbildschirm-Zugang erbitten
            function erbitteSperrbildschirm() {
                background.BackgroundExecutionManager.requestAccessAsync().then(
                    function (ergebnis) {
                        checkeSperrbildschirm(ergebnis);
                    });
            };

            // Kachel pinnen
            function kachelPinnen() {
                var startscreen = Windows.UI.StartScreen;

                var id = "kacheluhr";
                var kurzname = "Kacheluhr";
                var anzeigename = "Kacheluhr";
                var aktivierungsArguments = "uhr";
                var optionen = startscreen.TileOptions.none;
                var logo = new Windows.Foundation.Uri("ms-appx:///images/sekundaerKachel_150x150.png")

                var kachel = new startscreen.SecondaryTile(
                    id,
                    kurzname,
                    anzeigename,
                    aktivierungsArguments,
                    optionen,
                    logo);

                kachel.requestCreateAsync().then(
                    function (ergebnis) {
                        if (ergebnis == true) {
                            // Background Task registrieren & starten
                            BackgroundTasks.backgroundTaskAnmelden();
                        }
                    });
            }

            var appbar = document.getElementById("appbar");
            appbar.winControl.disabled = true;

        },

        unload: function () {
            // TODO: Respond to navigations away from this page.
            var appbar = document.getElementById("appbar");
            appbar.winControl.disabled = false;

            window.clearInterval(window.intervalUhr);
        },

        updateLayout: function (element, viewState, lastViewState) {
            /// <param name="element" domElement="true" />

            // TODO: Respond to changes in viewState.
        }
    });
})();
